{ Author: Ulli 'Framstag' Horlacher , framstag@rz.uni-ulm.de , Nov 1991 }

[ inherit('sys$library:pascal$lib_routines','sys$library:pascal$str_routines'),
  check(all) ]
      
program NSPLIT (input,output);
      
type  string80 = varying [80] of char;
      
var   uue_file                     : boolean;
      i,ii,pos,chan,lines          : integer;
      z                            : packed array [1..1] of char;      
      parameter,line,subj,fnam     : string80;
      fnames                       : array [1..99] of string80;
      tmpf                         : array [1..13000] of string80;
      inf,err                      : text;
      outf                         : array [1..99] of text;
      
begin 

lib$get_foreign(%descr parameter);
if parameter='' then begin
  writeln;
  writeln('NSPLIT splits uuencoded gif-files from *.pictures.* newsgroups');
  writeln('into files which can further processed by UUFIX. Just save all');
  writeln('articles into one big file.');
  writeln;
  write('Read from bigfile: ');
  readln(parameter);
end;
open(inf,parameter,history:=old);
reset(inf);
      
repeat
  readln(inf,line,error:=continue);
  str$upcase(%descr subj,%descr line);
  if substr(subj+'        ',1,8)='SUBJECT:' then begin
    pos:=index(subj,'.GIF');
    if pos=0 then pos:=index(subj,'.JPG');
    if pos>0 then begin
      i:=pos;
      repeat
        i:=i-1;
        z:=substr(subj,i,1);
      until not(z::char in ['0'..'9','A'..'Z','_','-']);
      fnam:=substr(subj,i+1,pos-i);
      ii:=0;
      uue_file:=false;
      repeat
        ii:=ii+1;
        readln(inf,tmpf[ii],error:=continue);
	if (ii>3) and (not(uue_file)) then uue_file:=substr(tmpf[ii]+' ',1,1)+
	  substr(tmpf[ii-1]+' ',1,1)+substr(tmpf[ii-2]+' ',1,1)='MMM';
      until (tmpf[ii]=chr(12)) or eof(inf);
      if uue_file then begin
        writeln('processing ',subj);
        chan:=0;
        i:=1;
        while (fnames[i]<>'') and (chan=0) do begin 
         if fnames[i]=fnam then chan:=i;
         i:=i+1;
        end;
        if chan=0 then begin
	  chan:=i;
          fnames[chan]:=fnam;
          open(outf[chan],fnam+'uue',history:=new);
          rewrite(outf[chan]);
        end;
        writeln(outf[chan]);
        writeln(outf[chan],subj);
        {writeln('subj:  "',subj,'"');}
	for i:=1 to ii do writeln(outf[chan],tmpf[i]);
      end;  
    end;  
  end;  
until eof(inf);
      
close (inf);

end.  
